#define F_CPU 16000000UL

#include <avr/io.h>
#include <util/delay.h>


#define BAUD 9600UL

#define UBRR_VAL ((F_CPU+BAUD*8)/(BAUD*16)-1)
#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1)))
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUD)

#if ((BAUD_ERROR<990) || (BAUD_ERROR>1010))
#error Systematischer Fehler der Baudrate groesser 1% und damit zu hoch!
#endif


void uart_init(void){
  UBRR0 = UBRR_VAL;
  UCSR0B |= (1<<TXEN0);
  UCSR0C = (1<<UCSZ01) | (1<<UCSZ00);
}

void  uart_putc(uint8_t c){
  while (!(UCSR0A & (1<<UDRE0))){}
  //  loop_until_bit_is_set(UCSR0A, UDRE0); /* Wait until data register empty. */
  
  UDR0 = c;
}

void uart_puts (uint8_t *s){
  while (*s){
    uart_putc( *s++ );
  }    
}


int main(void){
  uart_init();

  uint8_t a[] = "ABC";

  uint8_t b[] = "uint_8-ARRAY";

  uint8_t *c = "LITERAL";


  while (1){
    uart_puts(a);
    uart_putc('#');
    uart_puts(b);
    uart_putc('#');
    uart_puts(c);
    uart_putc('#');
    uart_puts("1234567890");
    uart_putc('#');
    for(uint8_t i='A';i<='Z';i++)
    uart_putc(i);
    uart_putc('\r');
    uart_putc('\n');
    _delay_ms(1000);
  }
}

